/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧قU-DiskłUSBν ް۰ދ@\܂݂܂(AVR916pLq)B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"

#ifndef HOST_UPGRADE_MODE
  #warning HOST_UPGRADE_MODE not defined as ENABLE or DISABLE, using DISABLE...
  #define HOST_UPGRADE_MODE  DISABLE
#endif

// ̧ тSYNC`Ԃɑ΂ĕKvȂ̂ݸٰނ܂B
#if (HOST_UPGRADE_MODE==ENABLE)

  #ifndef __ICCAVR__
  #error HOST_UPGRADE_MODE feature run only under IAR
  #endif

#include "modules/file_system/fat.h"
#include "modules/file_system/fs_com.h"
#include "modules/file_system/navigation.h"
#include "modules/file_system/file.h"
#include "modules/file_system/nav_utils.h"
#include "lib_mcu/flash/flash_lib.h"
#include "stdio.h"
#include "string.h"

//_____ ϸ ________________________________________________________________

// HEX̧ٓ̍sł̍őް
#define MAX_DATA_LINE		16

// F؂ꂽiグXV̒`
#define UPGRADE_SIZE_MAX	50
#define UPGRADE_ADDR		0x333

//_____ 錾 _______________________________________________________________

// ̔z"U-DiskłUSBν ް۰"@\ɂĊiグXVAׯ(=
// )̋Ԃ蓖Ă܂B
code char msg_to_upgrade[UPGRADE_SIZE_MAX] At(UPGRADE_ADDR);

// HEX̧ٕɎgp\
typedef struct
{
	U8	u8_nb_data;		// sɊ܂܂ް
	U16	u16_add;		// ްi[ڽ
	U8	u8_type;		// š`
	U8*	datas;			// sɊ܂܂ꂽް
}  St_hex_line;

// ̧ѳiグXVɎgpٰ
static	void	firm_upgrade_displayzone	(void);
static	void	firm_upgrade_status			(char *status);
static	Bool	firm_upgrade_searchfile		(const char* filename);
static	Bool	firm_upgrade_readhexline	(St_hex_line* line);
static	U8		firm_upgrade_ascii2bin		(U8 ascii);
static	U8		firm_upgrade_readbyte		(void);

//! ̊֐͊iグXVs܂B
//!
//! @verbatim
//! ̏ԂUARTŕ\AU-Disķ̏قɏ܂B
//! @endverbatim
//!
void firm_upgrade_run (void)
{
	Fs_index sav_index;
	U8 u8_i, save_int;
	St_hex_line hex_line;
	U8 datas[MAX_DATA_LINE];
	char filename[30];

	hex_line.datas   = datas;				// gpްɏՕ
	hex_line.u8_type = 0;					// `0݂̂F

	// ٰ݂𔲂Oɂ邽߂Ɍ݈ʒuۑ
	sav_index = nav_getindex();

	printf("\n\rDislpay upgrade zone BEFORE upgrade:\n\r");
	firm_upgrade_displayzone();

	printf("Search upgrade file\n\r...\r");
	if( !firm_upgrade_searchfile( "upgrade*" ) )
	{
		firm_upgrade_status("No upgrade file");
		nav_gotoindex(&sav_index);
		return;
	}

	nav_file_getname( filename, 50 );
	printf("Open upgrade file \"%s\"\n\r...\r", filename );
	if( !file_open(FOPEN_MODE_R) )
	{
		firm_upgrade_status("!! Error to open upgrade file");
		nav_gotoindex(&sav_index);			// Öʒu𕜌
		return;
	}

	printf("Check upgrade file\n\r...\r");
	while (!file_eof())
	{
		// e͍sɑ΂AiグXV
		hex_line.u8_nb_data = MAX_DATA_LINE;
		if( !firm_upgrade_readhexline( &hex_line ) )
		{
			file_close();
			firm_upgrade_status("!! Error in HEX file format");
			nav_gotoindex(&sav_index);
			return;
		}

		if( (hex_line.u16_add                      <  UPGRADE_ADDR)
		||  (hex_line.u16_add+hex_line.u8_nb_data) > (UPGRADE_ADDR+UPGRADE_SIZE_MAX) )
		{
			file_close();
			firm_upgrade_status("!! Upgrade zone not autorized");
			nav_gotoindex(&sav_index);
			return;
		}
	}

	printf("Program FLASH\n\r...\r");
	// ް۰ތ
	if( !flash_lib_check() )
	{
		file_close();
		firm_upgrade_status("!! The bootloder if not loaded");
		nav_gotoindex(&sav_index);
		return;
	}

	file_seek(0,FS_SEEK_SET);				// ̧ق̐擪ōĊJ
	while (!file_eof())
	{
		// e͍sɑ΂AiグXV
		hex_line.u8_nb_data = MAX_DATA_LINE;
		if( !firm_upgrade_readhexline( &hex_line ) )
		{
			file_close();
			firm_upgrade_status("!! Error in HEX file format");
			nav_gotoindex(&sav_index);
			return;
		}

		// 荞݋֎~
		save_int=Get_interrupt_state();
		Disable_interrupt();
		// ׯōڽ̌Ƌׯ
		flash_wr_block( hex_line.datas, hex_line.u16_add, hex_line.u8_nb_data );
		// ׯްǂݍ݂ƊɏՕƂ̏݌
		for( u8_i=0; u8_i<hex_line.u8_nb_data; u8_i++ )
		{
			if( hex_line.datas[u8_i] != flash_rd_byte((U8 farcode*)hex_line.u16_add) )
			{
				file_close();
				firm_upgrade_status("!! Programmation in flash BAD\n\r!!! Check if the bootloader is loaded in chip.");
				nav_gotoindex(&sav_index);
				return;
			}
			hex_line.u16_add++;
		}
		// 荞ݏԂ𕜌
		if(save_int) { Enable_interrupt(); }
	}

	file_close();
	firm_upgrade_status("Upgrade successfull");
	nav_gotoindex(&sav_index);

	printf("Dislpay upgrade zone AFTER upgrade:\n\r");
	firm_upgrade_displayzone();
}

//! ̧ѳiグXVɎgpԂUARTŕ\
//!
static void firm_upgrade_displayzone (void)
{
	char ram_msg_upgrade[UPGRADE_SIZE_MAX+1];

	// printfׯxȂ߁AׯRAMްړ
	for( U8 u8_i=0; u8_i<UPGRADE_SIZE_MAX; u8_i++ )
	{
		ram_msg_upgrade[u8_i] = msg_to_upgrade[u8_i];
	}
	ram_msg_upgrade[UPGRADE_SIZE_MAX]=0;	// ̏ꍇɏIqǉ
	printf( "\"" );
	printf( ram_msg_upgrade );
	printf( "\"\r\n" );
}

//! U-DiskUEX̧ق
//!
//! @param file 閼O
//!
//! @return ̧قꍇTRUE
//!
static Bool firm_upgrade_searchfile (const char* filename)
{
	U8 u8_drive_lun;

	//** SĂUSBި"Hello.txt"̧ق
	u8_drive_lun = 1;						// 1͂̎łUSB_P(LUN) (0=DataFlash,1=USBν)
	while (1)
	{
		if( u8_drive_lun >= nav_drive_nb() )
			return FALSE;
		// USBި
		nav_drive_set( u8_drive_lun );
		if( nav_partition_mount() )
		{
			// OKȂٌ̧
			if( nav_setcwd((FS_STRING)filename,TRUE,FALSE) )
				break;						// ̧ٔ
		}
		u8_drive_lun++;						// USBި
	}
	return TRUE;
}

//! HEX`ŕ͍sǂŕ
//!
//! @param line	\̂Ŏw:
//!				- u8_nb_data,	xް̍ő吔
//!				- datas,		ɏՕ𖞂l
//!
//! @return xsŖꂽs\̂ȂATRUE
//!
static Bool firm_upgrade_readhexline (St_hex_line* line)
{
	U8 u8_i, u8_nb_data, u8_crc=0;
	U8 *ptr_data;

	// s擪
	if( ':' != file_getc())
		return FALSE;

	// ްʎ擾
	u8_nb_data = firm_upgrade_readbyte();
	u8_crc += u8_nb_data;
	if( u8_nb_data > line->u8_nb_data )
		return FALSE;
	line->u8_nb_data = u8_nb_data;

	// ް ڽ擾
	line->u16_add = (((U16)firm_upgrade_readbyte())<<8) | firm_upgrade_readbyte();
	u8_crc += LSB(line->u16_add);
	u8_crc += MSB(line->u16_add);

	// ںތ`ǂݍ
	// - 00 : ް16ޯ ڽ܂ް ںށBŋLq`B
	// - 01 : ̧ق̍ŌںށAُ̧IںށBްȂB̧قɑ΂1āA̧ق̍ŏIsłȂ΂Ȃ܂BʏA':00000001FF'BAُ̧Iںނ͐ݒ肳۸тɑ΂Jnڽ܂߂邱ƂłAႦ:00AB2F0125ͱڽAB2F֔т܂B۸тꂽð߂ݒ肳鎞ɂ͕֗łB
	// - 02 : g ڽ ںށAĊڽB16ޯĂs\ɎgpA80x86̎ڽwƓlłB02ںނɂĎw肳ꂽڽ16{(4ޯčړ)A㑱00ںނ̱ڽɉZ܂BM޲Ă܂ł̱ڽԂ̱ڽw܂Bںނ̱ڽ̈0000A޲Đ02(Ă16ޯ)łȂ΂Ȃ܂B ڽ̍ŉ16i͏0łB
	// - 03 : Jn ڽ ںށB80x86۾ɑ΂āACS:IPڼ޽̏ew肵܂Bڽ̈0000A޲Đ04Aŏ2޲ĂCSlA2IPlłB
	// - 04 : S32ޯıڽwAgڽ ںށBڽ̈0000A޲Đ02łB`00ںނ̱ڽƑgݍ킹鎞ɁA2ް ޲Ă32ޯ ڽ̏16ޯĂ\܂B
	// - 05 : Jnڽ ںށBڽ̈0000A޲Đ04łB4ް ޲Ă80386ƂȏCPUEIPڼ޽Ɋi[32ޯĒl\܂B
	line->u8_type = firm_upgrade_readbyte();
	u8_crc += line->u8_type;

	// ް擾
	ptr_data = line->datas;
	for( u8_i=0; u8_i<u8_nb_data; u8_i++ )
	{
		*ptr_data = firm_upgrade_readbyte();
		u8_crc += *ptr_data;
		ptr_data++;
	}

	// CRC
	// (޲ĐAڽ̗޲āAںތ`Aeް ޲Ăт)SĂ޲Ă
	// Zтɐ΁Aŉ޲Ă͏0(0x00)łlɋA܂B
	u8_crc += firm_upgrade_readbyte();

	// s̍Ōǂݍ(='\r''\n')
	file_getc();file_getc();

	return( 0 == u8_crc );
}

//! ̊֐ިɊiグXV̏Ԃ̧ق쐬܂B
//!
//! @param status e
//!
static void firm_upgrade_status (char *status)
{
	char file_status_name[] = "status.txt";

	printf( status );
	printf( "\n\r" );

	// \ȂΏ̧ق쐬
	if( !nav_file_create((FS_STRING)file_status_name) )
	{
		if( fs_g_status != FS_ERR_FILE_EXIST )
			return;							// ٍ̧쐬Ɉُ
		// ّ̧݂Ōp
	}
	if( file_open(FOPEN_MODE_W) )
	{
		// ̧قɏԂ
		file_write_buf( (unsigned char*) status, strlen(status) );
		file_close();
	}
}

//! ̊֐ASCII4ޯĐl֕ϊ̂Ɏgp܂B
//! '5'5, 'A'10
//! 
//! @param ϊASCII
//!
//! @return ϊꂽ޲
//!
static U8 firm_upgrade_ascii2bin (U8 ascii)
{
	U8 byte=0;
	if( ('0'<=ascii) && (ascii<='9') )
		byte = ascii-'0';
	if( ('a'<=ascii) && (ascii<='f') )
		byte = (ascii-'a'+10);
	if( ('A'<=ascii) && (ascii<='F') )
		byte = (ascii-'A'+10);
	return byte;
}

//! ̊֐2ASCIIǂ޲Đlɕϊ܂B
//! '51'0x51, 'A1'0xA1
//!
//! @return ϊꂽ޲
//!
static U8 firm_upgrade_readbyte (void)
{
	U8 ascii_msb ,ascii_lsb;
	ascii_msb = file_getc();
	ascii_lsb = file_getc();
	return (firm_upgrade_ascii2bin(ascii_msb)<<4) | firm_upgrade_ascii2bin(ascii_lsb);
}

#endif // (HOST_UPGRADE_MODE==ENABLE)
