/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧قUSBνĐAνė(ڑF)菇A~ĊJνėvǗ܂B
//!
//! ̍Ƃ͌v敔Ƃ𔺂܂񂪁AWusb_task璼ړIɌĂ΂܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "modules/usb/usb_task.h"
#include "usb_host_task.h"
#include "lib_mcu/usb/usb_drv.h"
#include "lib_mcu/pll/pll_drv.h"
#include "modules/usb/host_chap9/usb_host_enum.h"

#if (USB_HUB_SUPPORT == ENABLE)
#include "modules/usb/host_chap9/usb_host_hub.h"
#endif

#if (USB_HOST_FEATURE == DISABLED)
  #warning trying to compile a file used with the USB HOST without USB_HOST_FEATURE enabled
#endif

#if (USB_HOST_FEATURE == ENABLED)

#ifndef DEVICE_BASE_ADDRESS
  #error DEVICE_BASE_ADDRESS should be defined somewhere in config files (conf_usb.h)
#endif

#ifndef SIZEOF_DATA_STAGE
  #error SIZEOF_DATA_STAGE should be defined in conf_usb.h
#endif

#ifndef HOST_CONTINUOUS_SOF_INTERRUPT
  #error HOST_CONTINUOUS_SOF_INTERRUPT should be defined as ENABLE or DISABLE in conf_usb.h
#endif

#ifndef USB_HOST_PIPE_INTERRUPT_TRANSFER
  #error USB_HOST_PIPE_INTERRUPT_TRANSFER should be defined as ENABLE or DISABLE in conf_usb.h
#endif

#ifndef Usb_id_transition_action
  #define Usb_id_transition_action()
#endif
#ifndef  Host_device_disconnection_action
  #define Host_device_disconnection_action()
#endif
#ifndef  Host_device_connection_action
  #define Host_device_connection_action()
#endif
#ifndef  Host_sof_action
  #define Host_sof_action()
#endif
#ifndef  Host_suspend_action
  #define Host_suspend_action()
#endif
#ifndef  Host_hwup_action
  #define Host_hwup_action()
#endif
#ifndef  Host_device_not_supported_action
  #define Host_device_not_supported_action()
#endif
#ifndef  Host_device_class_not_supported_action
  #define Host_device_class_not_supported_action()
#endif
#ifndef  Host_device_supported_action
  #define Host_device_supported_action()
#endif
#ifndef  Host_device_error_action
  #define Host_device_error_action()
#endif

//_____ ϸ ________________________________________________________________

#ifndef LOG_STR_CODE
#define LOG_STR_CODE(str)
#else
U8 code log_device_connected[]="Device Connection";
U8 code log_device_enumerated[]="Device Enumerated";
U8 code log_device_unsupported[]="Unsupported Device";
U8 code log_going_to_suspend[]="Usb suspend";
U8 code log_usb_resumed[]="Usb resumed";
#endif

//_____ ` _______________________________________________________________

//_____ 錾 _______________________________________________________________

#if (USB_HOST_PIPE_INTERRUPT_TRANSFER == ENABLE)
  volatile S_pipe_int	it_pipe_str[MAX_EP_NB];
  volatile U8 pipe_nb_save;
  U8 g_sav_int_sof_enable;
#endif

//!
//! J: U8 device_state
//! ̒lUSBνĐɐڑꂽǔ݂̏Ԃ\܂B
//! l͈ȉŗL蓾܂B
//! - DEVICE_ATTACHED
//! - DEVICE_POWERED
//! - DEVICE_SUSPENDED
//! - DEVICE_DEFAULT
//! - DEVICE_BASE_ADDRESSED
//! - DEVICE_CONFIGURED
//! - DEVICE_ERROR
//! - DEVICE_UNATTACHED
//! - DEVICE_READY
//! - DEVICE_WAIT_RESUME
//! - DEVICE_DISCONNECTED
//! - DEVICE_DISCONNECTED_ACK
//!/
U8 device_state;

//! ߲0̐vǗp
S_usb_setup_data usb_request;

//!
//! J: U8 data_stage[SIZEOF_DATA_STAGE];
//! USBްiKepRAMɏՕ
//! ̊ɏՕνė(ڑF)̍\ݒɕKvƂ܂B
//! ͎MuLqq܂݂܂B
//! uLqqɈˑāȂ傫conf_usb.ḩقSIZEOF_DATA_STAGE`ōœK邱Ƃł܂B
//!
//!/
U8 data_stage[SIZEOF_DATA_STAGE];

U8 device_status;
U8 request_resume = FALSE;
U8 force_enumeration = FALSE;
U8 new_device_connected = FALSE;

static U16 c;								// ڰщ񐔌vƂ

#if (USB_HUB_SUPPORT == ENABLE)
  static U8 i,j;
  volatile U8 hub_interrupt_sof=0;
  U8 saved_device;
#endif

/**
 * @brief ̊֐νē`ԂłUSBƒgϐ܂B
 *
 * ̊֐USBνē`Ԃŋ܂B
 *
 * @param	Ȃ
 *
 * @return	Ȃ
 *
 */
void usb_host_task_init (void)
{
	Pll_start_auto();
	Wait_pll_ready();
	Usb_disable();
	Usb_enable();
	Usb_unfreeze_clock();
	Usb_attach();
	Usb_enable_uvcon_pin();
	Usb_select_host();
	Usb_disable_vbus_hw_control();			// Ԓ߂ȂVBUS
	Host_enable_device_disconnection_interrupt();
	device_state=DEVICE_UNATTACHED;
	init_usb_tree();
}

/**
 * @brief USBνĊǗ̓_
 *
 * _͑u(device_state)ɈˑĖڕWuڑƗ(ڑF)Ǘ
 * ƂŁA֐͗񋓂Č`Ԑݒ肳ꂽu𓾂邽߂ɕKvȑs܂B
 * UuɂȂƁAdevice_statelDEVICE_READYłB
 * uɑ΂Ăǂȉpvŝɐ旧āȀԂνčƉpɂ
 * ČׂłB
 *
 * @param	Ȃ
 *
 * @return	Ȃ
 *
 * \image html host_task.gif
 */
void usb_host_task (void)
{

	switch (device_state)
	{
		//------------------------------------------------------
		// DEVICE_UNATTACHED
		//
		// - 菉
		// - ud͋^悤ƂB
		//
		case DEVICE_UNATTACHED:
			Host_clear_device_supported();	// uؾ
			Host_clear_configured();
			Host_clear_device_ready();
			Usb_clear_all_event();			// SĂ̿ĳۂ
			new_device_connected=FALSE;
			selected_device=0;

#if (USB_HUB_SUPPORT==ENABLE)
			nb_hub_present = 0;
#endif

#if (SOFTWARE_VBUS_CTRL==ENABLE)
			if( Is_usb_bconnection_error_interrupt()||Is_usb_vbus_error_interrupt())
			{
				Usb_ack_bconnection_error_interrupt();
				Usb_ack_vbus_error_interrupt();
				Host_clear_vbus_request();
			}
			Usb_disable_vbus_pad();
			Usb_enable_manual_vbus();
			if(Is_usb_srp_interrupt())
			{
				Usb_ack_srp_interrupt();
				Usb_enable_vbus_pad();
				Usb_enable_vbus();
				device_state=DEVICE_ATTACHED;
			}
#else
			Usb_enable_vbus();				// Œᑕud͋^!!!
			if(Is_usb_vbus_high())
			{ device_state=DEVICE_ATTACHED; }	// VBUSOKȂAuڑ\z֍s
#endif
			break;

		//------------------------------------------------------
		// DEVICE_ATTACHED
		//
		// - VBUSON
		// - oꂽuڑs
		//
		case DEVICE_ATTACHED:
			if (Is_device_connection() || (force_enumeration==TRUE))	// uٱߌo
			{
				Host_ack_device_connection();
				Host_clear_device_supported();	// uؾ
				Host_clear_configured();
				Host_clear_device_ready();
				Usb_clear_all_event();		// SĂ̿ĳۂ
				new_device_connected=FALSE;
				force_enumeration=FALSE;

				// ⑕uڑAؒf荞݋
				Host_enable_device_disconnection_interrupt();
				Enable_interrupt();
				// uؾ
				Host_clear_device_supported();
				Host_clear_configured();
				Host_clear_device_ready();
				Host_enable_sof();			// ڰъJn(SOF)Jn
				Host_enable_sof_interrupt();	// SOF͊荞݉Ōoł傤B
				c = 0;
				while (c<100)				// USBؾđO100msҋ@
				{
					if (Is_usb_event(EVT_HOST_SOF)) { Usb_ack_event(EVT_HOST_SOF); c++; }	// ڰъJnv
					if (Is_host_emergency_exit() || Is_usb_bconnection_error_interrupt()) {goto device_attached_error;}
				}
				Host_disable_device_disconnection_interrupt();
				Host_send_reset();			// ŏUSBؾ
				Usb_ack_event(EVT_HOST_SOF);
				while (Is_host_reset());	// ؾĂ̍Ō̊҂
				Host_ack_reset();
				// d͂̏Ȃٱ߂޸ނ̂邢̑uɑ΂΍
				// ʏްɂ₩ɏ㏸ᑬ(Low-Speed)͐ؒfƂĉ߂꓾܂B
				for(c=0;c!=0xFFFF;c++)		// {Ԓߌv
				{
					if(Is_usb_event(EVT_HOST_SOF))	// SOFȍꍇAu͑u͖ڑĐĂāAPɌĂؒf׸ނ܂B
					{
						if(Is_device_disconnection())
						{
							Host_ack_device_connection();
							Host_ack_device_disconnection();
							break;
						}
					}
				}
				Host_enable_device_disconnection_interrupt();
				// SĂUSB߲߂USBؾĐɍČ`Ԑݒ肳Ȃ΂Ȃ܂B
				host_configure_pipe(PIPE_CONTROL, \
									TYPE_CONTROL, \
									TOKEN_SETUP,  \
									EP_CONTROL,   \
									SIZE_64,      \
									ONE_BANK,     \
									0             );
				c = 0;
				while (c<100)				// USBؾČ100msҋ@
				{
					if (Is_usb_event(EVT_HOST_SOF)) { Usb_ack_event(EVT_HOST_SOF); c++; }	// ڰъJnv
					if (Is_host_emergency_exit() || Is_usb_bconnection_error_interrupt()) {goto device_attached_error;}
				}
				device_state = DEVICE_POWERED;
				c=0;
			}
			device_attached_error:
			// uڑُA܂VBUSd͒ቺˎn߂ڑ菇Ďs
			if( Is_usb_bconnection_error_interrupt()||Is_usb_vbus_error_interrupt()||Is_usb_vbus_low())
			{
				Usb_ack_bconnection_error_interrupt();
				Usb_enable_vbus_hw_control();
				device_state=DEVICE_UNATTACHED;
				Usb_disable_vbus();
				Usb_disable_vbus_pad();
				Usb_enable_vbus_pad();
				Usb_ack_vbus_error_interrupt();
				Usb_enable_vbus();
				Usb_disable_vbus_hw_control();
				Host_disable_sof();
			}
			break;

		//------------------------------------------------------
		// DEVICE_POWERED
		//
		// - uڑ(t)o
		// - 100msҋ@Ɗ萧߲ߌ`Ԑݒ
		//
		case DEVICE_POWERED:
			LOG_STR_CODE(log_device_connected);
			Host_device_connection_action();
			if (Is_usb_event(EVT_HOST_SOF))
			{
				Usb_ack_event(EVT_HOST_SOF);
				if (c++ >= 100)				// 100msҋ@
				{
					device_state = DEVICE_DEFAULT;
				}
			}
			break;

		//------------------------------------------------------
		// DEVICE_DEFAULT
		//
		// - uLqq擾
		// - u߲0ɏ]߲0Č`Ԑݒ
		// - uڽ𑮂B
		//
		case DEVICE_DEFAULT:
			// ŏ̑uLqq擾
			Host_select_device(0);
			usb_tree.device[0].ep_ctrl_size=8;
			if( CONTROL_GOOD == host_get_device_descriptor_uncomplete())
			{
				c = 0;
				while(c<20)					// USBؾČ20msҋ@(ʂ޸ޑû)
				{
					if (Is_usb_event(EVT_HOST_SOF)) { Usb_ack_event(EVT_HOST_SOF); c++; }
					if (Is_host_emergency_exit() || Is_usb_bconnection_error_interrupt())  {break;}
				}
				Host_disable_device_disconnection_interrupt();
				Host_send_reset();			// ŏUSBؾ
				Usb_ack_event(EVT_HOST_SOF);
				while (Is_host_reset());	// ؾĂ̍Ō̊҂
				Host_ack_reset();
				// d͂̏Ȃٱ߂޸ނ̂邢̑uɑ΂΍
				// ʏްɂ₩ɏ㏸ᑬ(Low-Speed)͐ؒfƂĉ߂꓾܂B
				for(c=0;c!=0xFFFF;c++)		// {Ԓߌv
				{
					if(Is_usb_event(EVT_HOST_SOF))	// SOFȍꍇAu͑u͖ڑĐĂāAPɌĂؒf׸ނ܂B
					{
						if(Is_device_disconnection())
						{
							Host_ack_device_connection();
							Host_ack_device_disconnection();
							break;
						}
					}
				}
				Host_enable_device_disconnection_interrupt();
				c = 0;
				host_configure_pipe(PIPE_CONTROL, \
									TYPE_CONTROL, \
									TOKEN_SETUP,  \
									EP_CONTROL,   \
									SIZE_64,      \
									ONE_BANK,     \
									0             );
				while(c<200)				// USBؾČ200msҋ@
				{
					if (Is_usb_event(EVT_HOST_SOF)) { Usb_ack_event(EVT_HOST_SOF); c++; }
					if (Is_host_emergency_exit() || Is_usb_bconnection_error_interrupt())  {break;}
				}
				usb_tree.device[0].ep_ctrl_size=data_stage[OFFSET_FIELD_MAXPACKETSIZE];

				// Αuڽ^B
				host_set_address(DEVICE_BASE_ADDRESS);
				usb_tree.device[0].device_address=DEVICE_BASE_ADDRESS;
				device_state = DEVICE_ADDRESSED;
			}
			else
			{ device_state = DEVICE_ERROR; }
			break;

		//------------------------------------------------------
		// DEVICE_BASE_ADDRESSED
		//
		// - VIDPIDxꗗ
		//
		case DEVICE_ADDRESSED:
			if (CONTROL_GOOD == host_get_device_descriptor())
			{
				// ڑꂽuxu\ɑm
				if (HOST_TRUE == host_check_VID_PID())
				{
					Host_set_device_supported();
					Host_device_supported_action();
					device_state = DEVICE_CONFIGURED;
				}
				else
				{
				#if (HOST_STRICT_VID_PID_TABLE==ENABLE)
					Host_device_not_supported_action();
					device_state = DEVICE_ERROR;
				#else
					device_state = DEVICE_CONFIGURED;
				#endif
				}
			}
			else // uLqq𓾂ȂB
			{ device_state = DEVICE_ERROR; }
			break;

		//------------------------------------------------------
		// DEVICE_CONFIGURED
		//
		// - x̪ɑ΂߲߂`Ԑݒ
		// - Set_configuration()vo
		// - S`Ԃ֍s(u)
		//
		case DEVICE_CONFIGURED:
			if (CONTROL_GOOD == host_get_configuration_descriptor())
			{
				if (HOST_FALSE != host_check_class())	// ׽xOK?
				{
					usb_tree.nb_device++;
				#if (HOST_AUTO_CFG_ENDPOINT==ENABLE)
					if(host_auto_configure_endpoint())
				#else
					Host_set_configured();	// `Ԑݒ͎gpҌ`ԐݒOKƉ
					if(User_configure_endpoint())	// gp҂͎`Ԑݒ̑ɂŌĂяo
				#endif
					{
						if (CONTROL_GOOD== host_set_configuration(1))	// Set_configurationo
						{
//							host_set_interface(interface_bound,interface_bound_alt_set);
							// uνĂ͍⊮SɌ`Ԑݒ肳܂B
							// DEVICE READYW֍sB
							device_state = DEVICE_READY;
							Host_set_device_ready();
							// 荞݉őuؒfĎ
							Host_enable_device_disconnection_interrupt();
							// gpνĉpSOF荞ݎۂKvȏꍇ
							// SOF荞݋ۂAȂ΂̊荞݂֎~
						#if (HOST_CONTINUOUS_SOF_INTERRUPT==DISABLE && USB_HUB_SUPPORT==DISABLE)
							Host_disable_sof_interrupt();
						#endif
						#if (USB_HUB_SUPPORT==ENABLE)
							// ڑꂽuނ
							if(Get_class(0)==HUB_CLASS && Get_subclass(0)==0x00 && Get_protocol(0)==0x00)
							{
								// ދLqq擾
								if( Get_hub_descriptor()==CONTROL_GOOD)
								{
									// ނ̊e߰Ăɋd
									i=data_stage[NB_PORT_OFFSET];
									for(c=1;c<=i;c++)
									{
										Set_port_feature(PORT_POWER,c);
									}
									nb_hub_present = 1;
									hub_device_address[0]=DEVICE_BASE_ADDRESS;
									hub_init(nb_hub_present-1);
								}
							}
							else
							{
								nb_hub_present = 0;
								new_device_connected=TRUE;
							}
						#else
							new_device_connected=TRUE;
						#endif

							Enable_interrupt();
							LOG_STR_CODE(log_device_enumerated);
						}
						else // Set_configurationv̖
						{ device_state = DEVICE_ERROR; }
					}
				}
				else // u׽xȂB
				{
					device_state = DEVICE_ERROR;
					LOG_STR_CODE(log_device_unsupported);
					Host_device_class_not_supported_action();
				}
			}
			else // `ԐݒLqq擾łȂB
			{ device_state = DEVICE_ERROR; }
			break;

		//------------------------------------------------------
		// DEVICE_READY
		//
		// - SW`
		// - ׂƂ͉Ȃ
		//
		case DEVICE_READY:					// νĊSW`!
			new_device_connected=FALSE;

		#if (USB_HUB_SUPPORT==ENABLE)
			f_hub_port_disconnect=FALSE;
			// USB؍\1ނ݂A ߲Ċ荞ݗp̎ԊuNꍇ
			if(nb_hub_present && hub_interrupt_sof==0)
			{
				saved_device=selected_device;	// gp҂Iuޯ
				for(j=1;j<=nb_hub_present;j++)
				{
					for(i=0;i<MAX_DEVICE_IN_USB_TREE;i++)
					{
						if(usb_tree.device[i].device_address==hub_device_address[j-1]) break;
					}
					Host_select_device(i);
					Host_select_pipe(usb_tree.device[i].interface[0].ep[0].pipe_number);
					Host_ack_nak_received();
					Host_ack_in_received();
					Host_unfreeze_pipe();
					Host_send_in();
					while(1)
					{
						if(Is_host_nak_received())   break;
						if(Is_host_emergency_exit()) break;
						if(Is_host_in_received())    break;
					}
					Host_freeze_pipe();
					if(Is_host_nak_received())
					{
						Host_ack_nak_received();
					}
					if(Is_host_in_received())
					{
						if(Is_host_stall()==FALSE)
						{
							c=Host_read_byte();
						}
						Host_ack_in_received();
						hub_manage_port_change_status(c,j);
					}
				} // SĂނɑ΂
				Host_select_device(saved_device);	// gpґIu𕜌
			#if (USER_PERIODIC_PIPE==ENABLE)
				unfreeze_user_periodic_pipe();
			#endif
			}
		#endif
			break;

		//------------------------------------------------------
		// DEVICE_ERROR
		//
		// - ُ
		// - ƎĂ(蓮`Ԃ֍s)
		//
		case DEVICE_ERROR:					// ׂ!!!!
		#if (HOST_ERROR_RESTART==ENABLE)
			device_state=DEVICE_UNATTACHED;
		#endif
			Host_device_error_action();
			break;

		//------------------------------------------------------
		// DEVICE_SUSPENDED
		//
		// - νĉp͑ůx~邱Ƃv
		// - Host_request_suspend()ɂďԋ@\͂ɗ܂B
		//
		case DEVICE_SUSPENDED:
			if(Is_device_supports_remote_wakeup())	// ڑꂽuuNxꍇ
			{
				host_set_feature_remote_wakeup();	// ̋@\
			}
			LOG_STR_CODE(log_going_to_suspend);
			c = Is_host_sof_interrupt_enabled();	// ݂SOF荞݋Ԃۑ
			Host_disable_sof_interrupt();
			Host_ack_sof();
			Host_disable_sof();				// ڰъJn(SOF)~A͋x~(Suspend)Ԃ𐶐܂B
			Host_ack_hwup();
			Host_enable_hwup_interrupt();	// νċNオ芄荞݋
											// (ܰ޳ݓ삩CPUNオ点邱ƂłƎUSB荞݂łB
			Usb_freeze_clock();
			Stop_pll();
			Host_suspend_action();			// Ǝ͂! (Ⴆܰޓ֍sȂ)
			device_state=DEVICE_WAIT_RESUME;	// uĊJ(Resume)ۑ҂
			break;

		//------------------------------------------------------
		// DEVICE_WAIT_RESUME
		//
		// - νĂuĊJ(Resume)󂯎܂ŁA܂
		// - ν ĳuɍĊJv܂ł̏Ԃő҂
		//
		case DEVICE_WAIT_RESUME:
			if(Is_usb_event(EVT_HOST_HWUP)|| Is_host_request_resume())	// uNo܂͋ǏĊJvM
			{
				if(Is_host_request_resume())	// uNł͂ȂAνĉpv
				{
					Host_disable_hwup_interrupt();	// Nオ芄荞݂νĂNオċ֎~ׂłB
					// x:HWUPUSBۯɎɂ邱Ƃł܂B
					Pll_start_auto();		// USB̂߂̍ŏPLLĎn
					Wait_pll_ready();		// PLLŒ艻mF擾
					Usb_unfreeze_clock();	// USB̸̪ۯ
					Host_ack_hwup();		// HWUP荞׸މ
				}
				Host_enable_sof();
				Host_send_resume();			// ĊJ(Resume)o
				while (Is_host_down_stream_resume()==FALSE);	// ĊJo҂
				Host_ack_remote_wakeup();	// uNM
				Host_ack_request_resume();	// ĳv
				Host_ack_down_stream_resume();	// ĊJo
				Usb_ack_event(EVT_HOST_HWUP);	// ĳۉ
				if(c) { Host_enable_sof_interrupt(); }	// x~(Suspend)OSOF荞݋Ԃ𕜌
				device_state=DEVICE_READY;	// S`ԕA
				LOG_STR_CODE(log_usb_resumed);
			}
			break;

		//------------------------------------------------------
		// DEVICE_DISCONNECTED
		//
		// - uؒfo
		// - νĉpƂɂČoꂽmȎۂ𓾂邽߂ɍŒ2񂱂̏ԂŌv敔𑖍s
		// - v敔SpƂĂԂ̂mɓ邽߂DEVICE_UNATTACHED̑ODEVICE_DISCONNECTED_ACKԂ֍sB
		//
		case DEVICE_DISCONNECTED:
			device_state = DEVICE_DISCONNECTED_ACK;
			break;

		//------------------------------------------------------
		// DEVICE_DISCONNECTED_ACK
		//
		// - uؒfoĉpƂɂĊǗ܂B
		// - DEVICE_UNATTACHEDԂ֍sB
		//
		case DEVICE_DISCONNECTED_ACK:
			device_state = DEVICE_UNATTACHED;
			break;

		//------------------------------------------------------
		// 
		//
		// - : ERROR
		// - uԂȂ֍sB
		//
		default:
			device_state = DEVICE_UNATTACHED;
			break;
	}
}

//___ Ǘꂽް̗߰ݸނ邽ߊ֐ _______________________________

/**
  * @brief ̊֐͎w肳ꂽ߲ߔԍ*bufŎwnb_data𑗂܂B
  *
  * @note ̊֐͎Ԓ߂o邽߂νSOF荞݂ɂ܂B荞݋SOF͕܂B
  * interrupt enable sof will be restore.
  *
  * @param	pipe
  * @param	nb_data
  * @param	buf
  *
  * @return	
  */
U8 host_send_data (U8 pipe, U16 nb_data, U8 *buf)
{
	U8 c;
	U8 status=PIPE_GOOD;
	U8 sav_int_sof_enable;
	U8 nak_timeout;
	U16 cpt_nak;
	U8 nb_data_loaded;
	U8 cpt_err_timeout=0;

#if (USER_PERIODIC_PIPE==ENABLE)
	freeze_user_periodic_pipe();
#endif
	sav_int_sof_enable=Is_host_sof_interrupt_enabled();	// SOF荞݋ԕۑ
	Host_enable_sof_interrupt();
	Host_select_pipe(pipe);
	Host_set_token_out();
	Host_ack_out_sent();
	Host_unfreeze_pipe();

	while (nb_data != 0)					// 鉽
	{
		// ׂް
		c = Host_get_pipe_length();
		if ( (U16)c > nb_data)
		{
			nb_data_loaded = (U8)nb_data;
			c = nb_data;
		}
		else
		{ nb_data_loaded = c; }
		while (c!=0)						// ߲ߊɏՕݒ
		{
			Host_write_byte(*buf++);
			c--;
		}
		private_sof_counter=0;				// SOFoٰݓ̌vؾ
		cpt_nak=0;
		nak_timeout=0;
		Host_ack_out_sent();
		Host_send_out();
		while (!Is_host_out_sent())
		{
			if (Is_host_emergency_exit())	// 荞݉Ōoꂽ񓯊ؒf܂͖ύX
			{
				status=PIPE_DELAY_TIMEOUT;
				Host_reset_pipe(pipe);
				goto host_send_data_end;
			}
			#if (TIMEOUT_DELAY_ENABLE==ENABLE)
			if (private_sof_counter>=250)	// 250msv(250SOF)
			{
				private_sof_counter=0;
				if (nak_timeout++>=TIMEOUT_DELAY)	// oߎԐisƈꌟ
				{
					status=PIPE_DELAY_TIMEOUT;
					Host_reset_pipe(pipe);
					goto host_send_data_end;
				}
			}
			#endif
			if (Is_host_pipe_error())		// ُ?
			{
				status = Host_error_status();
				Host_ack_all_errors();
				if(status == PIPE_TIMEOUT)
				{
					if(cpt_err_timeout++>100)
					{
						goto host_send_data_end;
					}
					else
					{
						c=0;
						while(c<2)			// 2msҋ@
						{
							if (Is_usb_event(EVT_HOST_SOF)) { Usb_ack_event(EVT_HOST_SOF); c++; }
							if (Is_host_emergency_exit() )  {break;}
						}

						Host_unfreeze_pipe();
					}
				}
			}
			if (Is_host_stall())			// s\(Stall)Ǘ
			{
				status =PIPE_STALL;
				Host_ack_stall();
				goto host_send_data_end;
			}
			#if (NAK_TIMEOUT_ENABLE==ENABLE)
			if(Is_host_nak_received())		// NAKM
			{
				Host_ack_nak_received();
				if (cpt_nak++>NAK_SEND_TIMEOUT)
				{
					status = PIPE_NAK_TIMEOUT;
					Host_reset_pipe(pipe);
					goto host_send_data_end;
				}
			}
			#endif
		}
		// OUTo
		nb_data -= nb_data_loaded;
		status=PIPE_GOOD;					// ڰѐ푗o
		Host_ack_out_sent();
	}
	while(0!=Host_number_of_busy_bank());

host_send_data_end:
	Host_freeze_pipe();
	// SOF荞݋ԕ
	if (sav_int_sof_enable==FALSE)   {Host_disable_sof_interrupt();}
	#if (USER_PERIODIC_PIPE==ENABLE)
	unfreeze_user_periodic_pipe();
	#endif
	// ĕA
	return ((U8)status);
}

/**
  * @brief ̊֐͎w肳ꂽ߲ߔԍ*bufŎwnb_data󂯎܂B
  *
  * nb_dataҰU16߲ƂēnA]Ă߲ɂĎwꂽް
  * ͎󂯎ŏIIް ޲ĐōXV܂B
  *
  * @param	pipe
  * @param	nb_data
  * @param	buf
  *
  * @return	
  */
U8 host_get_data (U8 pipe, U16 *nb_data, U8 *buf)
{
	U8 status=PIPE_GOOD;
	U8 sav_int_sof_enable;
	U8 nak_timeout;
	U16 n,i;
	U16 cpt_nak;

	#if (USER_PERIODIC_PIPE==ENABLE)
	freeze_user_periodic_pipe();
	#endif
	n=*nb_data;
	*nb_data=0;
	sav_int_sof_enable=Is_host_sof_interrupt_enabled();
	Host_enable_sof_interrupt();
	Host_select_pipe(pipe);
	Host_continuous_in_mode();
	Host_set_token_in();
	Host_ack_in_received();
	while (n)								// ް蓦Ă
	{
		Host_unfreeze_pipe();
		Host_send_in();
		private_sof_counter=0;				// SOFoٰݓ̌vؾ
		nak_timeout=0;
		cpt_nak=0;
		while (!Is_host_in_received())
		{
			if (Is_host_emergency_exit())	// 荞݉Ōoꂽ񓯊ؒf܂͖ύX
			{
				status=PIPE_DELAY_TIMEOUT;
				Host_reset_pipe(pipe);
				goto host_get_data_end;
			}
			#if (TIMEOUT_DELAY_ENABLE==ENABLE)
			if (private_sof_counter>=250)	// ԒߊǗ
			{
				private_sof_counter=0;		// νSOF荞݂ōs܂B
				if (nak_timeout++>=TIMEOUT_DELAY)	// ǏԒߌ
				{
					status=PIPE_DELAY_TIMEOUT;
					Host_reset_pipe(pipe);
					goto host_get_data_end;
				}
			}
			#endif
			if(Is_host_pipe_error())		// ُǗ
			{
				status = Host_error_status();
				Host_ack_all_errors();
				goto host_get_data_end;
			}
			if(Is_host_stall())				// s\(STALL)Ǘ
			{
				if( Is_host_in_received() )
					break;
				status =PIPE_STALL;
				Host_reset_pipe(pipe);
				Host_ack_stall();
				goto host_get_data_end;
			}
			#if (NAK_TIMEOUT_ENABLE==ENABLE)
			if(Is_host_nak_received())		// NAKM
			{
				Host_ack_nak_received();
				if (cpt_nak++>NAK_RECEIVE_TIMEOUT)
				{
					status = PIPE_NAK_TIMEOUT;
					Host_reset_pipe(pipe);
					goto host_get_data_end;
				}
			}
			#endif
		}
		status=PIPE_GOOD;
		Host_freeze_pipe();
		if (Host_byte_counter()<=n)
		{
			if ((Host_byte_counter() < n)&&(Host_byte_counter()<Host_get_pipe_length()))
			{ n=0;}
			else
			{ n-=Host_byte_counter();}
			(*nb_data)+=Host_byte_counter();	// M޲ĐXV
			if( NULL != buf )
			{
				for (i=Host_byte_counter();i;i--)
				{ *buf=Host_read_byte(); buf++;}
			}
		}
		else // \zM޲
		{	// ׂ:ُ필Ǘ
			*nb_data+=n;
			if( NULL != buf )
			{
				for (i=n;i;i--)				// vɐ޲Đ(limit tab over pb)
				{ *buf=Host_read_byte(); buf++; }
			}
			n=0;
		}
		Host_ack_in_received();
	}
	Host_freeze_pipe();
host_get_data_end:
	if (sav_int_sof_enable==FALSE)
	{
		Host_disable_sof_interrupt();
	}
	#if (USER_PERIODIC_PIPE==ENABLE)
	unfreeze_user_periodic_pipe();
	#endif
	return ((U8)status);
}

//___ 荞݊Ǘꂽް̗p֐ _________________________

#if (USB_HOST_PIPE_INTERRUPT_TRANSFER == ENABLE)

void reset_it_pipe_str (void)
{
	U8 i;
	for(i=0;i<MAX_EP_NB;i++)
	{
		it_pipe_str[i].enable=DISABLE;
		it_pipe_str[i].timeout=0;
	}
}

U8 is_any_interrupt_pipe_active (void)
{
	U8 i;
	for(i=0;i<MAX_EP_NB;i++)
	{
		if(it_pipe_str[i].enable==ENABLE) return TRUE;
	}
	return FALSE;
}

/**
  * @brief ̊֐͎w肵߲ߔԍ*bufŎwnb_data󂯎܂B
  *
  * nb_dataҰU16߲ƂēnA]Ă߲ɂĎwް
  * ͎󂯎ŏIIް ޲ĐōXV܂B
  *
  * @param	pipe
  * @param	nb_data
  * @param	buf
  * @param	handle	Ăі߂֐߲
  *
  * @return	
  */
U8 host_get_data_interrupt (U8 pipe, U16 nb_data, U8 *buf,void(*handle)(U8 status, U16 nb_byte))
{
	Host_select_pipe(pipe);
	if(it_pipe_str[pipe].enable==ENABLE)
	{
		return HOST_FALSE;
	}
	else
	{
		if(is_any_interrupt_pipe_active()==FALSE)
		{
			g_sav_int_sof_enable=Is_host_sof_interrupt_enabled();
			Host_enable_sof_interrupt();
		}
		it_pipe_str[pipe].enable=ENABLE;
		it_pipe_str[pipe].nb_byte_to_process=nb_data;
		it_pipe_str[pipe].nb_byte_processed=0;
		it_pipe_str[pipe].ptr_buf=buf;
		it_pipe_str[pipe].handle=handle;
		it_pipe_str[pipe].timeout=0;
		it_pipe_str[pipe].nak_timeout=NAK_RECEIVE_TIMEOUT;

		private_sof_counter=0;				// SOFoٰݓ̌vؾ
		Host_reset_pipe(pipe);
		Host_enable_stall_interrupt();
		#if (NAK_TIMEOUT_ENABLE==ENABLE)
		Host_enable_nak_interrupt();
		#endif
		Host_enable_error_interrupt();
		Host_enable_receive_interrupt();
		Host_ack_stall();
		Host_ack_nak_received();

		Host_continuous_in_mode();
		Host_set_token_in();
		Host_ack_in_received();
		Host_unfreeze_pipe();
		return HOST_TRUE;
	}
}

/**
  * @brief ̊֐͎w肵߲ߔԍ*bufŎwnb_data𑗂܂B
  *
  * @param	pipe
  * @param	nb_data
  * @param	buf
  * @param	handle	Ăі߂֐߲
  *
  * @return	
  */
U8 host_send_data_interrupt (U8 pipe, U16 nb_data, U8 *buf, void(*handle)(U8 status, U16 nb_byte))
{
	U8 i;
	U8 *ptr_buf=buf;

	Host_select_pipe(pipe);
	if(it_pipe_str[pipe].enable==ENABLE)
	{
		return HOST_FALSE;
	}
	else
	{
		if(is_any_interrupt_pipe_active()==FALSE)
		{
			g_sav_int_sof_enable=Is_host_sof_interrupt_enabled();
			Host_enable_sof_interrupt();
		}
		it_pipe_str[pipe].enable=ENABLE;
		it_pipe_str[pipe].nb_byte_to_process=nb_data;
		it_pipe_str[pipe].nb_byte_processed=0;
		it_pipe_str[pipe].ptr_buf=buf;
		it_pipe_str[pipe].handle=handle;
		it_pipe_str[pipe].timeout=0;
		it_pipe_str[pipe].nak_timeout=NAK_SEND_TIMEOUT;
		it_pipe_str[pipe].nb_byte_on_going=0;

		Host_reset_pipe(pipe);
		Host_unfreeze_pipe();
		// ׂް
		i = Host_get_pipe_length();
		if ( i > nb_data)					// ߲ߗe>cް
		{
			i = nb_data;
			nb_data = 0;
		}
		else								// ߲ߗeʁcް
		{
			nb_data -= i;
		}
		it_pipe_str[pipe].nb_byte_on_going+=i;	// ްXV
		while (i!=0)						// ߲ߊɏՕݒ
		{ Host_write_byte(*ptr_buf++); i--;
		}
		private_sof_counter=0;				// SOFoٰݓ̌vؾ
		it_pipe_str[pipe].timeout=0;		// ԌoߌvĊ
		Host_ack_out_sent();
		Host_ack_stall();
		Host_ack_nak_received();

		Host_enable_stall_interrupt();
		Host_enable_error_interrupt();
		#if (NAK_TIMEOUT_ENABLE==ENABLE)
		Host_enable_nak_interrupt();
		#endif
		Host_enable_transmit_interrupt();
		Host_send_out();					// USBڰёo
		return HOST_TRUE;
	}
}

//! @brief USB߲ߊ荞ݻٰ
//!
//! @param	Ȃ
//!
//! @return	Ȃ
#ifdef __GNUC__
ISR(USB_COM_vect)
#else
#pragma vector = USB_Endpoint_Pipe_vect
__interrupt void usb_pipe_interrupt()
#endif
{
	U8 pipe_nb;
	U8 *ptr_buf;
	void  (*fct_handle)(U8 status,U16 nb_byte);
	U16 n;
	U8 i;
	U8 do_call_back=FALSE;

	pipe_nb_save = Host_get_selected_pipe();	// dv! ߲ߔԍŕۑ
	pipe_nb=usb_get_nb_pipe_interrupt();	// 荞݂𐶐鐳߲ߔԍœB
	Host_select_pipe(pipe_nb);				// ߲߂I
	fct_handle=*(it_pipe_str[pipe_nb].handle);

	// ǂ̎ۂ荞݂𐶐o݂B

	if (Is_host_pipe_error())				// ُ?
	{
		it_pipe_str[pipe_nb].status = Host_error_status();
		it_pipe_str[pipe_nb].enable=DISABLE;
		Host_stop_pipe_interrupt(pipe_nb);
		Host_ack_all_errors();
		do_call_back=TRUE;
		goto usb_pipe_interrupt_end;
	}

	if (Is_host_stall())					// s\(Stall)޼M?
	{
		it_pipe_str[pipe_nb].status=PIPE_STALL;
		it_pipe_str[pipe_nb].enable=DISABLE;
		Host_stop_pipe_interrupt(pipe_nb);
		do_call_back=TRUE;
		goto usb_pipe_interrupt_end;
	}

	#if (NAK_TIMEOUT_ENABLE==ENABLE)
	if (Is_host_nak_received())				// NAK?
	{
		Host_ack_nak_received();
		// NAKԒ߈ُ픭̔ԍ(荞݌`߲߂ɑ΂Ăł͂Ȃ)
		if((--it_pipe_str[pipe_nb].nak_timeout==0) && (Host_get_pipe_type()!=TYPE_INTERRUPT))
		{
			it_pipe_str[pipe_nb].status=PIPE_NAK_TIMEOUT;
			it_pipe_str[pipe_nb].enable=DISABLE;
			Host_stop_pipe_interrupt(pipe_nb);
			do_call_back=TRUE;
			goto usb_pipe_interrupt_end;
		}
	}
	#endif

	if (Is_host_in_received())				// ߲INM?
	{
		ptr_buf=it_pipe_str[pipe_nb].ptr_buf+it_pipe_str[pipe_nb].nb_byte_processed;	// ްɏՕւ߲\z
		n=it_pipe_str[pipe_nb].nb_byte_to_process-it_pipe_str[pipe_nb].nb_byte_processed;	// cް ޲
		Host_freeze_pipe();
		if (Host_byte_counter()<=n)
		{
			if ((Host_byte_counter() < n)&&(Host_byte_counter()<Host_get_pipe_length()))	// c薢MA߲ߗeʖ
											// ׂ:ُ필
			{
				n=0;
			}
			else
			{
				n-=Host_byte_counter();
			}
			it_pipe_str[pipe_nb].nb_byte_processed+=Host_byte_counter();	// M޲ĐXV
			for (i=Host_byte_counter();i;i--)
			{ *ptr_buf=Host_read_byte(); ptr_buf++;}
		}
		else  // \M޲
		{     // ׂ:ُ필Ǘ
			it_pipe_str[pipe_nb].nb_byte_processed+=n;
			for (i=n;i;i--)					// vɐ޲Đ(limit tab over pb)
			{ *ptr_buf=Host_read_byte(); ptr_buf++;}
			n=0;
		}
		Host_ack_in_received();
		if(n>0)								// ̂߂̉
		{
			Host_unfreeze_pipe();			// ʂIN]v
			Host_send_in();
			private_sof_counter=0;			// SOFoٰݓ̌vؾ
			it_pipe_str[pipe_nb].timeout=0;	// oߎؾ
			it_pipe_str[pipe_nb].nak_timeout=NAK_RECEIVE_TIMEOUT;
		}
		else								// ]I
		{
			it_pipe_str[pipe_nb].enable=DISABLE;
			it_pipe_str[pipe_nb].status=PIPE_GOOD;
			Host_stop_pipe_interrupt(pipe_nb);
			do_call_back=TRUE;
		}
	}

	if(Is_host_out_sent())					// ߲OUTo?
	{
		Host_ack_out_sent();
		it_pipe_str[pipe_nb].nb_byte_processed+=it_pipe_str[pipe_nb].nb_byte_on_going;
		it_pipe_str[pipe_nb].nb_byte_on_going=0;
		ptr_buf=it_pipe_str[pipe_nb].ptr_buf+it_pipe_str[pipe_nb].nb_byte_processed;	//  ްɏՕւ߲\z
		n=it_pipe_str[pipe_nb].nb_byte_to_process-it_pipe_str[pipe_nb].nb_byte_processed;  // Remaining data bytes
		if(n>0)								// ̂߂ް
		{
			Host_unfreeze_pipe();
			// ׂް
			i = Host_get_pipe_length();
			if ( i > n)						// ߲ߗe>cް
			{
				i = n;
				n = 0;
			}
			else							// ߲ߗeʁcް
			{ n -= i; }
			it_pipe_str[pipe_nb].nb_byte_on_going+=i;	// ꂽްXV
			while (i!=0)					// ߲ߊɏՕݒ
			{
				Host_write_byte(*ptr_buf++); i--;
			}
			private_sof_counter=0;			// SOFoٰݓ̌vؾ
			it_pipe_str[pipe_nb].timeout=0;	// ԒߌvĊ
			it_pipe_str[pipe_nb].nak_timeout=NAK_SEND_TIMEOUT;
			Host_send_out();				// USBڰёo
		}
		else								// n==0A]I
		{
			it_pipe_str[pipe_nb].enable=DISABLE;	// ]I
			it_pipe_str[pipe_nb].status=PIPE_GOOD;	// OK
			Host_stop_pipe_interrupt(pipe_nb);
			do_call_back=TRUE;
		}
	}

usb_pipe_interrupt_end:
	Host_select_pipe(pipe_nb_save);			// ߲ߔԍ!!!!
	if (is_any_interrupt_pipe_active()==FALSE)	// ȏ]ꍇ
	{
		if (g_sav_int_sof_enable==FALSE)
		{
			Host_disable_sof_interrupt();
		}
	}
	if(do_call_back)						// s邽߂̉ꂩ̌Ăі߂֐?
	{
		fct_handle(it_pipe_str[pipe_nb].status,it_pipe_str[pipe_nb].nb_byte_processed);
	}
}
#endif

#endif // USB_HOST_FEATURE ENABLE
